
public final class SimplifiedEVoting {
   private boolean secret;
   public Result result;
   int n; //number of candidates
   int[] votesX, votesY;
   /*! result | secret ; !*/
   
   protected final /*@ spec_public @*/ Result compute(int[] votes){
	Result rs = new Result(n);

	for(int i = 0; i< votes.length; i++){
             if(votes[i]>=0 && votes[i]<n)
            	rs.bulletin[votes[i]] = rs.bulletin[votes[i]] + 1;
   	}
      return rs;
   }


   /*@requires 
	(votesX.length == votesY.length) && (votesX.length>5) && n>=2 && n<=4 && (votesX.length<10)
         && (\forall int j; j>=0 && j<votesX.length; votesX[j]>=0 && votesX[j]<n && votesY[j]>=0 && votesY[j]<n)
         && (\forall int i; i>=0 && i<n; (\sum int j; 0 <= j && j < votesX.length; (votesX[j]==i ? 1 : 0))==(\sum int j; 0 <= j && j < votesY.length; (votesY[j]==i ? 1 : 0)) );
    @ diverges true;
    @*/
   public void magic(/*int[] votes1, int[] votes2*/){
      if(secret)
         result = compute(votesX);
      else
         result = compute(votesY);
   }
}

